/*
 * ContactFacade.java
 *
 * Created on 19 kwiecie 2007, 19:41
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package facades;

import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import persistence.Contact;

/**
 *
 * @author Tomek
 */
@Stateless
public class ContactFacade extends Facade implements ContactFacadeRemote {
    
    /** Creates a new instance of ContactFacade */
    public ContactFacade() {
    }

    public void create(Contact contact,DatabaseChoice databaseChoice) {
        getEntityManager(databaseChoice).persist(contact);
    }

    public void edit(Contact contact,DatabaseChoice databaseChoice) {
        getEntityManager(databaseChoice).merge(contact);
    }

    public void destroy(Contact contact,DatabaseChoice databaseChoice) {
        getEntityManager(databaseChoice).merge(contact);
        getEntityManager(databaseChoice).remove(contact);
    }

    public Contact find(Object pk,DatabaseChoice databaseChoice) {
        return (Contact) getEntityManager(databaseChoice).find(Contact.class, pk);
    }
    
    public Contact findByContact( Contact contact ,DatabaseChoice databaseChoice) {
        
        String query = "select object(c) from Contact as c where ( c.city = '"
            + contact.getCity() + "' and c.street = '" + contact.getStreet()
            + "' and c.streetNumber = '" + contact.getStreetNumber()
            + "' and c.apartamentNumber = '" + contact.getApartamentNumber()
            + "' and c.phoneNumber = '" + contact.getPhoneNumber()
            + "' and c.countryId = :countryId )";
        
        return (Contact) getEntityManager(databaseChoice).createQuery( query )
            .setParameter( "countryId", contact.getCountryId() ).getSingleResult();
    }
    
    public List findAll(DatabaseChoice databaseChoice) {
        return getEntityManager(databaseChoice).createQuery("select object(o) from Contact as o").getResultList();
    }
    
}
