/*
 * CountryFacade.java
 *
 * Created on 19 kwiecie 2007, 19:41
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package facades;

import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import persistence.Country;

/**
 *
 * @author Tomek
 */
@Stateless
public class CountryFacade extends Facade implements CountryFacadeRemote {   
    
    /** Creates a new instance of CountryFacade */
    public CountryFacade() {
    }

    public void create(Country country, DatabaseChoice databaseChoice) {
        getEntityManager(databaseChoice).persist(country);
    }

    public void edit(Country country, DatabaseChoice databaseChoice) {
        getEntityManager(databaseChoice).merge(country);
    }

    public void destroy(Country country, DatabaseChoice databaseChoice) {
        getEntityManager(databaseChoice).merge(country);
        getEntityManager(databaseChoice).remove(country);
    }

    public Country find(Object pk, DatabaseChoice databaseChoice) {
        return (Country) getEntityManager(databaseChoice).find(Country.class, pk);
    }

    public List findAll( DatabaseChoice databaseChoice) {
        return getEntityManager(databaseChoice).createQuery("select object(o) from Country as o").getResultList();
    }
    
}
