/*
 * OfficeFacade.java
 *
 * Created on 19 kwiecie 2007, 19:41
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package facades;

import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import persistence.Office;

/**
 *
 * @author Tomek
 */
@Stateless
public class OfficeFacade extends Facade implements OfficeFacadeRemote {
    
    /** Creates a new instance of OfficeFacade */
    public OfficeFacade() {
    }

    public void create(Office office,DatabaseChoice databaseChoice) {
        getEntityManager(databaseChoice).persist(office);
    }

    public void edit(Office office,DatabaseChoice databaseChoice) {
        getEntityManager(databaseChoice).merge(office);
    }

    public void destroy(Office office,DatabaseChoice databaseChoice) {
        getEntityManager(databaseChoice).merge(office);
        getEntityManager(databaseChoice).remove(office);
    }

    public Office find(Object pk,DatabaseChoice databaseChoice) {
        return (Office) getEntityManager(databaseChoice).find(Office.class, pk);
    }

    public List findAll(DatabaseChoice databaseChoice) {
        return getEntityManager(databaseChoice).createQuery("select object(o) from Office as o").getResultList();
    }
    
}
