/*
 * UserFacade.java
 *
 * Created on 19 kwiecie 2007, 19:41
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package facades;

import java.util.Date;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import persistence.User;

/**
 *
 * @author Tomek
 */
@Stateless
public class UserFacade extends Facade implements UserFacadeRemote {
    
    /** Creates a new instance of UserFacade */
    public UserFacade() {
    }

    public void create(User user,DatabaseChoice databaseChoice) {
        getEntityManager(databaseChoice).persist(user);
    }

    public void edit(User user,DatabaseChoice databaseChoice) {
        getEntityManager(databaseChoice).merge(user);
    }

    public void destroy(User user,DatabaseChoice databaseChoice) {
        user = getEntityManager(databaseChoice).merge(user);
        getEntityManager(databaseChoice).remove(user);
    }

    public User find(Object pk,DatabaseChoice databaseChoice) {        
        return (User) getEntityManager(databaseChoice).find(User.class, pk);
    }
    
    public User findByLogin(String login, DatabaseChoice databaseChoice) {
        return (User) getEntityManager(databaseChoice).createQuery(
            "SELECT u FROM User u WHERE u.login = '" + login + "'").getSingleResult();
    }

    public List findAll(DatabaseChoice databaseChoice) {
        return getEntityManager(databaseChoice).createQuery("select object(o) from User as o").getResultList();
    }
 
    public List findRemoved(DatabaseChoice databaseChoice) {
        EntityManager em = getEntityManager(databaseChoice);
        em.clear();
        return em.createNamedQuery( "User.findByChangeStamp" ).
                setParameter("changeStamp",new Date(0L))
                .getResultList();
    }
    
    public List findNewOrModified( Date fromTimeStamp, Date toTimeStamp ,DatabaseChoice databaseChoice) {
        return getEntityManager(databaseChoice).createNamedQuery( "User.findNewOrModified" ).
                setParameter( "fromChangeStamp", fromTimeStamp )
                .setParameter( "toChangeStamp", toTimeStamp )
                .getResultList();
    }
}
