/*
 * DeliveriesOfficesPK.java
 *
 * Created on 19 kwiecie 2007, 19:38
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package persistence;

import java.io.Serializable;
import java.util.Date;
import javax.persistence.Column;
import javax.persistence.Embeddable;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;

/**
 * Primary Key class DeliveriesOfficesPK for entity class DeliveriesOffices
 * 
 * @author Tomek
 */
@Embeddable
public class DeliveriesOfficesPK implements Serializable {

    @Column(name = "delivery_id", nullable = false)
    private long deliveryId;

    @Column(name = "office_id", nullable = false)
    private long officeId;

    @Column(name = "existed_time", nullable = false)
    @Temporal(TemporalType.TIMESTAMP)
    private Date existedTime;
    
    /** Creates a new instance of DeliveriesOfficesPK */
    public DeliveriesOfficesPK() {
    }

    /**
     * Creates a new instance of DeliveriesOfficesPK with the specified values.
     * @param existedTime the existedTime of the DeliveriesOfficesPK
     * @param officeId the officeId of the DeliveriesOfficesPK
     * @param deliveryId the deliveryId of the DeliveriesOfficesPK
     */
    public DeliveriesOfficesPK(Date existedTime, long officeId, long deliveryId) {
        this.existedTime = existedTime;
        this.officeId = officeId;
        this.deliveryId = deliveryId;
    }

    /**
     * Gets the deliveryId of this DeliveriesOfficesPK.
     * @return the deliveryId
     */
    public long getDeliveryId() {
        return this.deliveryId;
    }

    /**
     * Sets the deliveryId of this DeliveriesOfficesPK to the specified value.
     * @param deliveryId the new deliveryId
     */
    public void setDeliveryId(long deliveryId) {
        this.deliveryId = deliveryId;
    }

    /**
     * Gets the officeId of this DeliveriesOfficesPK.
     * @return the officeId
     */
    public long getOfficeId() {
        return this.officeId;
    }

    /**
     * Sets the officeId of this DeliveriesOfficesPK to the specified value.
     * @param officeId the new officeId
     */
    public void setOfficeId(long officeId) {
        this.officeId = officeId;
    }

    /**
     * Gets the existedTime of this DeliveriesOfficesPK.
     * @return the existedTime
     */
    public Date getExistedTime() {
        return this.existedTime;
    }

    /**
     * Sets the existedTime of this DeliveriesOfficesPK to the specified value.
     * @param existedTime the new existedTime
     */
    public void setExistedTime(Date existedTime) {
        this.existedTime = existedTime;
    }

    /**
     * Returns a hash code value for the object.  This implementation computes 
     * a hash code value based on the id fields in this object.
     * @return a hash code value for this object.
     */
    @Override
    public int hashCode() {
        int hash = 0;
        hash += (this.existedTime != null ? this.existedTime.hashCode() : 0);
        hash += (int)officeId;
        hash += (int)deliveryId;
        return hash;
    }

    /**
     * Determines whether another object is equal to this DeliveriesOfficesPK.  The result is 
     * <code>true</code> if and only if the argument is not null and is a DeliveriesOfficesPK object that 
     * has the same id field values as this object.
     * @param object the reference object with which to compare
     * @return <code>true</code> if this object is the same as the argument;
     * <code>false</code> otherwise.
     */
    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof DeliveriesOfficesPK)) {
            return false;
        }
        DeliveriesOfficesPK other = (DeliveriesOfficesPK)object;
        if (this.existedTime != other.existedTime && (this.existedTime == null || !this.existedTime.equals(other.existedTime))) return false;
        if (this.officeId != other.officeId) return false;
        if (this.deliveryId != other.deliveryId) return false;
        return true;
    }

    /**
     * Returns a string representation of the object.  This implementation constructs 
     * that representation based on the id fields.
     * @return a string representation of the object.
     */
    @Override
    public String toString() {
        return "persistence.DeliveriesOfficesPK[existedTime=" + existedTime + ", officeId=" + officeId + ", deliveryId=" + deliveryId + "]";
    }
    
}
